"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const material_1 = require("@mui/material");
const TreeItem_1 = require("@mui/x-tree-view/TreeItem");
const classnames_1 = tslib_1.__importDefault(require("classnames"));
const react_1 = require("react");
const CustomContent = (0, react_1.forwardRef)(function CustomContent(props, ref) {
    const { classes, className, label, nodeId } = props;
    const { disabled, expanded, selected, focused, handleSelection, handleExpansion, } = (0, TreeItem_1.useTreeItem)(nodeId);
    const handleClick = (event) => {
        handleExpansion(event);
        handleSelection(event);
        if (props.onClick) {
            props.onClick(event);
        }
    };
    return ((0, jsx_runtime_1.jsx)(material_1.Box, { className: (0, classnames_1.default)(className, classes.root, {
            [classes.expanded]: expanded,
            [classes.selected]: selected,
            [classes.focused]: focused,
            [classes.disabled]: disabled,
        }), sx: {
            padding: "0px 8px",
        }, onClick: handleClick, ref: ref, children: label }));
});
exports.default = CustomContent;
