"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const TreeItem_1 = require("@mui/x-tree-view/TreeItem");
const ChevronRight_1 = tslib_1.__importDefault(require("@mui/icons-material/ChevronRight"));
const material_1 = require("@mui/material");
const ExpandMore_1 = tslib_1.__importDefault(require("@mui/icons-material/ExpandMore"));
const DEFAULT_COLLAPSE_ICON = (0, jsx_runtime_1.jsx)(ExpandMore_1.default, {});
const DEFAULT_EXPAND_ICON = (0, jsx_runtime_1.jsx)(ChevronRight_1.default, {});
const TreeItemLabel = ({ node, titleRender, onLazyLoad, loading, collapseIcon = DEFAULT_COLLAPSE_ICON, expandIcon = DEFAULT_EXPAND_ICON, }) => {
    const { expanded, handleExpansion, preventSelection, handleSelection } = (0, TreeItem_1.useTreeItem)(node.key);
    const hasLazyLoad = typeof node.children != "undefined" && node.children.length == 0;
    const handleExpansionClick = async (event) => {
        if (loading) {
            return;
        }
        if (hasLazyLoad) {
            onLazyLoad && onLazyLoad();
        }
        else {
            handleExpansion(event);
        }
        event.stopPropagation();
        event.preventDefault();
        preventSelection(event);
    };
    (0, react_1.useEffect)(() => {
        if (expanded && hasLazyLoad) {
            onLazyLoad && onLazyLoad();
        }
    }, [expanded]);
    const hasChildren = typeof node.children != "undefined";
    const icon = hasChildren ? ((0, jsx_runtime_1.jsxs)("div", { onClick: handleExpansionClick, className: "MuiTreeItem-iconContainer", children: [expanded && collapseIcon, !expanded && expandIcon] })) : ((0, jsx_runtime_1.jsx)("div", { className: "MuiTreeItem-iconContainer" }));
    return ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [loading && ((0, jsx_runtime_1.jsx)("div", { className: "MuiTreeItem-iconContainer", children: (0, jsx_runtime_1.jsx)(material_1.CircularProgress, { color: "inherit", size: 12 }) })), !loading && icon, (0, jsx_runtime_1.jsx)("div", { className: "MuiTreeItem-label", children: titleRender ? titleRender(node) : node.title })] }));
};
exports.default = TreeItemLabel;
