"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const TreeItem_1 = require("@mui/x-tree-view/TreeItem");
const CustomContent_1 = tslib_1.__importDefault(require("./CustomContent"));
const Label_1 = tslib_1.__importDefault(require("./Label"));
const fast_deep_equal_1 = tslib_1.__importDefault(require("fast-deep-equal"));
const TreeItem = ({ node, titleRender, lazyLoadFn, renderChildren, onExpand, treeItemClasses, ContentComponent, collapseIcon, expandIcon, ...rest }) => {
    const [children, setChildren] = (0, react_1.useState)(node.children);
    const hasChildren = !!(children && children.length);
    const hasLazyLoad = typeof children != "undefined" && children.length == 0;
    const isMountRef = (0, react_1.useRef)(false);
    const [loading, setLoading] = (0, react_1.useState)(false);
    const handleLazyLoad = async () => {
        setLoading(true);
        const nodes = await lazyLoadFn({
            key: node.key,
            children: node.children,
        });
        node.children = nodes;
        setChildren(nodes);
        onExpand(node.key);
        setLoading(false);
    };
    const handleClick = async (event) => {
        if (hasLazyLoad) {
            await handleLazyLoad();
        }
    };
    (0, react_1.useEffect)(() => {
        if (isMountRef.current) {
            if (node.children != children) {
                if (!(0, fast_deep_equal_1.default)(node.children, children)) {
                    setChildren(node.children);
                }
            }
        }
    }, [node.children]);
    (0, react_1.useEffect)(() => {
        isMountRef.current = true;
        return () => {
            isMountRef.current = false;
        };
    }, []);
    return ((0, jsx_runtime_1.jsx)(TreeItem_1.TreeItem, { ContentComponent: ContentComponent ?? CustomContent_1.default, nodeId: node.key, disabled: node.disabled, ...rest, classes: treeItemClasses, onClick: handleClick, label: (0, jsx_runtime_1.jsx)(Label_1.default, { loading: loading, titleRender: titleRender, onLazyLoad: handleLazyLoad, collapseIcon: collapseIcon, expandIcon: expandIcon, node: node }), children: renderChildren(node, children) }, node.key));
};
exports.default = TreeItem;
