import React from "react";
import { TreeItemContentProps, TreeItemProps as MuiTreeItemProps } from "@mui/x-tree-view/TreeItem";
import { TreeNode } from "./types";
interface TreeItemsProps extends Omit<MuiTreeItemProps, "nodeId"> {
    node: TreeNode;
    treeItemClasses: any;
    titleRender?: (node: TreeNode) => React.ReactNode;
    lazyLoadFn?: (args: {
        key: string;
        children: TreeNode[];
    }) => Promise<any[]>;
    renderChildren: (parentNode: TreeNode, children: TreeNode[]) => React.ReactNode;
    onExpand: (nodeKey: string) => void;
    ContentComponent?: React.JSXElementConstructor<TreeItemContentProps>;
    collapseIcon?: React.ReactNode;
    expandIcon?: React.ReactNode;
}
declare const TreeItem: ({ node, titleRender, lazyLoadFn, renderChildren, onExpand, treeItemClasses, ContentComponent, collapseIcon, expandIcon, ...rest }: TreeItemsProps) => import("react/jsx-runtime").JSX.Element;
export default TreeItem;
