import React from "react";
import { TreeViewProps as MuiTreeViewProps } from "@mui/x-tree-view/TreeView";
import { TreeItemClasses, TreeItemContentProps } from "@mui/x-tree-view/TreeItem";
import { TreeNode } from "./types";
interface ITreeViewProps<Multiple extends boolean | undefined> extends MuiTreeViewProps<Multiple> {
    treeData: TreeNode[];
    titleRender?: (node: TreeNode) => React.ReactNode;
    lazyLoadFn?: (args: {
        key: string;
        children: TreeNode[];
    }) => Promise<TreeNode[]>;
    treeItemClasses?: Partial<TreeItemClasses>;
    ContentComponent?: React.JSXElementConstructor<TreeItemContentProps>;
}
declare const TreeView: <Multiple extends boolean = undefined>({ treeData, lazyLoadFn, treeItemClasses, titleRender, ContentComponent, expanded: expandedProp, onNodeToggle: onNodeToggleProp, defaultCollapseIcon, defaultExpandIcon, ...treeProps }: ITreeViewProps<Multiple>) => import("react/jsx-runtime").JSX.Element;
export default TreeView;
